;
; AC, re-ecriture a partir de AC_VERSIONS_OPTIONS
; et ajout des commentaires le 10/11/2003
;
; This program helps to switch in the "best" mode for X-windows, i.e.:
; true-color 24 bits colors, active backing-store, and should allow
; to have correct colors on 8-bits terminal
;
; To be really activated, this program must be run before any grachics
;
; Warning:
; - this program did not activate a color table (cf AC_COLORS_INIT)
;
; ----------------------------
;
; il reste plusieurs troubles ici:
; - je ne sais pas recuperer la variable systeme qui code le nombre
;   de couleurs du l'ecran actif ...
; - si on est sur un Terminal-X ou un ecran distant (client) en 8 bits,
;   on demande quand meme du 24b (serveur): on a n'importe quoi comme
;   couleurs
; - a priori, les bugs 8/16/24 bits des couleurs sous IDL Linux 5.4 et
;   5.5 ont ete corriges
; --> ceci devient peut-etre moins necessaire et demanderait
;    a evoluer avec les versions d'IDL !
; ----------------------------
; Liste des modifs:
;
; le 18/08/2004: suite a une remarque de M Giard, gestion pour
; MS-Windows
; le 19/05/2005: meilleur gestion de !version.os_family
; ----------------------------
;
pro AC_DISPLAY_INIT, help=help
;
mess=AC_SETMESSAGES('AC_DISPLAY_INIT')
;
if KEYWORD_SET(help) then begin
    print, 'pro AC_DISPLAY_INIT, help=help'
    print, ''
    print, 'AC_DISPLAY_INIT switchs to TruColor, 24-bits and BackingStore modes.'
    print, 'To really activated these options, this program must be run before any grachics.'
    print, ''
    print, 'CALLING SEQUENCE : AC_DISPLAY_INIT'
    
    return
endif
;
; By default, we would like :
;   1/ to switch in TrueColor (24 bits) (DEVICE, True_Color=24)
;   2/ to have the backing store activated (IDL will do it )(DEVICE, Retain=2)
;   3/ to be able to display without too much trouble on any old
;   X-ternimals (DEVICE, Decomposed=0)
;
; AC le 19/05/2005: BQ rapporte que !version.os_family sous MS-win
; rend un "mot" melangeant minuscules et majuscules ...
;
version_os_family=STRlowCASE(!version.os_family)
;
if (version_os_family EQ 'unix') then begin	
    print, mess.info+'options for Unix/Linux/MacOS-X activated'
    DEVICE, TRUE=24, DECOMPOSED=0, retain=2
endif
if (version_os_family EQ 'windows') then begin
    ;; ha la la !
    print, mess.info+'options for platform MS-windows activated'
    DEVICE, DECOMPOSED=0, retain=2
endif
;
; On utilise un petit bout de code de LOADCT (procedure IDL)
; pour initialiser au mieux les couleurs des fenetre X
;
if (!d.name eq 'X') and (!d.window eq -1) then begin ;Uninitialized?
    ;;If so, make a dummy window to determine the # of colors available.
    ;; premiere fenetre "vide" (/pixmap) au dessus de 32 (/free)
    WINDOW, /free, /pixmap, xs=4, ys=4
    ;; lorsqu'on ouvre une fenetre, son numero courant est stocke dans
    ;; la variable systeme !d.window, ce qui permet de fermer la bonne !
    WDELETE, !d.window
endif
;
end
