;
; Creation par AC le 02/04/2003 a l'IRAM PdBi
;
; Historique des modifications:
;
function IS_FIELD_IN_STRUCT, struct_name, field_name, $
                             bavard=bavard, debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('IS_FIELD_IN_STRUCT')
;
if (N_PARAMS() lt 2) then begin
    print, mess.fatal+'missing arguments'
    help=1
endif
;
if KEYWORD_SET(help) then begin
    print, 'function IS_FIELD_IN_STRUCT, struct_name, field_name, $'
    print, '          bavard=bavard, debug=debug, test=test, help=help'
    return, -1
endif
;
liste_flag=STRPOS(TAG_NAMEs(struct_name),STRUPCASE(field_name))
;
flag=0
liste=WHERE((liste_flag GE 0), count)
if (count EQ 1) then begin
    flag=1
endif
if (count GT 1) then begin
    print, mess.fatal+'Tag_names was found several times !'
    STOP
endif
;
if KEYWORD_SET(bavard) then begin
    txt= STRCOMPRESS(mess.info+'Tag_name "'+field_name)
    if (flag EQ 0) then print, txt+'" was NOT found'
    if (flag EQ 1) then print, txt+'" was found'
endif
;
if KEYWORD_SET(debug) then begin
    print, mess.info+'Tag_names of the struture:', TAG_NAMEs(struct_name)
    print, mess.info+'Researched Tag_name:', STRUPCASE(field_name)
    HELP
endif
;
if KEYWORD_SET(test) OR KEYWORD_SET(debug) then STOP
;
return, flag
;
end
;
